using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Units;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IUnitRepository
    {
        Task<BaseResult> Add(UnitElastic Unit);
        Task<BaseResult> AddManyAsync(IEnumerable<UnitElastic> Units);
        Task<SmartTableResult<UnitElastic>> Search(BoolQueryDescriptor<UnitElastic> query);
        Task<SmartTableResult<UnitElastic>> GetByIds(List<long> ids);
        Task<SmartTableResult<UnitElastic>> GetAll();

    }
    public class UnitRepository : IUnitRepository
    {
        private readonly ElasticIndex<UnitElastic> _dbContext;

        public UnitRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<UnitElastic>(settings.Value.ClusterUrl, "inventoryunit");
        }


        public async Task<SmartTableResult<UnitElastic>> Search(BoolQueryDescriptor<UnitElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(UnitElastic Unit)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Unit);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<UnitElastic> Units)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Units);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<UnitElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<UnitElastic>();
            var idsQ = new QueryContainerDescriptor<UnitElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }
        public async Task<SmartTableResult<UnitElastic>> GetAll()
        {
            var query = new BoolQueryDescriptor<UnitElastic>();
            var isdeletedQ  = new QueryContainerDescriptor<UnitElastic>();
            isdeletedQ.Terms(t => t.Field(f => f.IsDeleted).Terms(false));
            query.Filter(f => isdeletedQ);
            return await _dbContext.Search(query);
        }
    }
}
